<?xml version="1.0"?>

<st-source>
<!-- Changes in change set RA503202 -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on November 9, 2009 at 9:23:06 am</time-stamp>


<methods>
<class-id>PROVISO.UBA.UniversalModelInterface</class-id> <category>smee accessing</category>

<body package="PVAdaptor-New Generation" selector="smeeCurrentDate">smeeCurrentDate
	&lt;getterNamed: #currentDate&gt;
	
	currentDate ifNil: [currentDate := self timeFacade now asUTCSeconds].
	^currentDate</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UniversalModelInterface</class-id> <category>accessing</category>

<body package="PVAdaptor-New Generation" selector="currentDate">currentDate
	"previous code used time now to default in"
	"it's too early here to make the distinction to use now"
	^currentDate</body>

<body package="PVAdaptor-New Generation" selector="subelementsByDate">subelementsByDate
	"return a sorted collection of the subelement"
	
	| aColl |
	aColl := SortedCollection new sortBlock: [:a :b | (a date ifNil: [0]) &lt;= (b date ifNil: [0])].
	aColl addAll: self subelements values.
	^aColl</body>
</methods>

<methods>
<class-id>PROVISO.UBA.UniversalModelInterface</class-id> <category>actions</category>

<body package="PVAdaptor-New Generation" selector="basicAddMetric:">basicAddMetric: aMetric 
	
	self updateDateFor: aMetric.
	aMetric date ifNil: [aMetric date: self timeFacade now asUTCSeconds].
	self currentSubelement isNil 
		ifTrue: 
			[self outputWriter updateTimestampFrom: aMetric.
			self outputWriter 
				writeMetric: aMetric
				onCollector: (self collectorNumberForMetric: aMetric)
				resync: false]
		ifFalse: 
			[aMetric resource: self currentSubelement.
			self currentSubelement addMetric: aMetric]</body>

<body package="PVAdaptor-New Generation" selector="updateAggregatingDateFor:">updateAggregatingDateFor: anObject 
	
	self 
		updateDateFor: anObject.
	"if we are nil by now, we have to assume now"
	"the code before returned if date was nil, but it never was"
 	"it was inserting current date before it got here"
	"i'm only setting now if there is no other alternative"
     anObject date ifNil: [anObject date: self timeFacade now asUTCSeconds].
	(anObject date &gt; self endOfPeriodSeconds or:[anObject date &lt; self startOfPeriodSeconds])
		ifTrue: 
			[self inlineFlush.
			self startOfPeriodSeconds: 
				(anObject date truncateTo: anObject aggregationInterval).
			self endOfPeriodSeconds: 
				self startOfPeriodSeconds + anObject aggregationInterval - 1].
	anObject date: self startOfPeriodSeconds</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAAbstractServer</class-id> <category>adapting</category>

<body package="PVAdaptor-Application" selector="handleInputError:for:">handleInputError: ex for: anInputDescriptor 
	(ex isNested and: [ex isResumable]) ifTrue: [ex pass].
	anInputDescriptor ignoreProcessing 
		ifTrue: 
			[self system 
				logWarning: #INPUT_ERROR
				messageId: #DL39213
				template: '&lt;1s&gt;'
				arguments: (Array with: ex description).
			anInputDescriptor doNotProcess]
		ifFalse: [self handleInputError: ex]</body>
</methods>


<methods>
<class-id>PROVISO.PvUniversalOutputWriter</class-id> <category>writing</category>

<body package="PV-NM-Inventory-Application" selector="updateTimestampFrom:">updateTimestampFrom: anObject 
	
	| seconds |
	(seconds := anObject date) ifNil: 
		[anObject date: self currentSeconds.
		anObject date ifNil: [anObject date: self adaptor modelInterface currentDate].
		anObject date ifNil: [anObject date: self timeFacade now asUTCSeconds].
		seconds := anObject date].
	self updateTimestamp: seconds</body>
</methods>



</st-source>
